#Define PLAYER_MAX_COUNT 8

Type snake_controller
	Public:
		player_count As Integer=0
		player(PLAYER_MAX_COUNT) As snake
		
		_ic As item_controller_fwd Ptr
		
		obstacle_list As obstacle Ptr=0
		obstacle_count As Integer Ptr=0
		
		speed0 As Single =0.3f
		length0 As Integer =3
		snake_snake_collision As Integer=0
		dead_snake_collision As Integer=0
		
		allDead As Integer =0
		
		Declare Constructor()
		Declare Sub addPlayer(ByRef _name As String, ByRef _red As UByte, ByRef _green As UByte, ByRef _blue As UByte, ByRef _x As Integer, ByRef _y As Integer, ByRef _direction As Integer)
		Declare Sub handleEvents(ByRef _event As SDL_Event)
		Declare Sub doStep()
		Declare Sub drawScores()
		
		Declare Sub define_ic (ByVal _ic As item_controller_fwd Ptr)
		Declare Sub define_obstacles(ByVal _oc As Integer Ptr, ByVal _ol As obstacle Ptr)
		Declare Sub triggerMove(ByRef _player As snake)
		Declare Sub triggerEat(ByRef _player As snake, ByRef _item As item)
		
		Declare Sub triggerDigest(ByRef _player As snake)
		
		Declare Sub death_enqueue(ByRef _pnum As Integer)
		
	Private:
		Declare Sub triggerDie(ByRef _player As snake)
		Declare Sub death_queue_empty()
		death_count As Integer =0
		death_queue(PLAYER_MAX_COUNT) As Integer
End Type
